if __FILE__ == $0
  scrPath = File::dirname($0.gsub(/\\/, '/')).sub(/\/ldoce4$/, '')
  $LOAD_PATH.unshift(scrPath)     # XNvgpX[hpXɒǉ
end

require 'ldoce4/gaizi'
require 'ldoce4/cfg'

require "rexml/document"
include REXML

### Activator ڎf[^
class ActMenu

  SEP_LINE = '' * 10  # ؂

  SEP_GAIZI = "\xC2\xA0"  # ؂

  def initialize(home, outf)
    @f = outf
    @relconcept = CfgTda::new(home, CFG_ACT_CONTENTS)
    @relword = CfgLin::new(home, CFG_EXP_LIST)
#    makeHeadwordsTable()
  end

  def close
    @relconcept.close
    @relword.close
  end

  def makeHeadwordsTable
    reccount = 0
    @headwords = Hash::new

    @relconcept.each do |rec|
      section = rec['section']
      if section == 0
        reccount += 1
      else
        title = @relconcept.getdata(rec)
        if @headwords.key?(section)
          @headwords[section][rec['expo'] - 1] = title
        else
          a = Array::new(1)
          a[rec['expo'] - 1] = title
          @headwords[section] = a
        end
      end
    end

    reccount
  end

  def do(source)
    doc = Document.new(source, { :ignore_whitespace_nodes => :all })
    root = doc.root

    @ids = []

    root.elements.each do |e|
      case e.attributes['class']
      when 'consept_selec_m'
        @f.print '<h1 id="', ID_CHAR, e.attributes['id'], '">'
        e.elements.each('span[@class="ConceptSelected"]') do |s|
          @f.print s.text
        end
        @f.print "</h1>\n"
      else
        block(e)
      end
    end

    @f.print '<p>', SEP_LINE, "</p>\n"

    @ids
  end

  def block(node)

    cl = node.attributes['class']

    stag = etag = ''
    case cl
    when 'fondbox_bleu_cl'    # ֘A
      stag = ''; etag = '<p>' + SEP_LINE + "</p>\n"
    when 'reltitle2'          # ֘ARZvgx
      stag = '<p><b>'; etag = "</b></p>\n"
    when 'xblphrase_box'      # ֘ARZvg
      @relconceptid = node.attributes['id'].to_i
      stag = '<p>&nbsp;&nbsp;'; etag = "</p>\n"
    when 'show'
    when 'bordure_box_ht_m'
    when 'bordure_box_bs_m'
      ;
    when 'secList'
      id = node.attributes['id']
      @ids.push(id.to_i)
      stag = '<p id="' + ID_CHAR + id + ID_SUFFIX + '">'; etag = "</p>\n"
    when 'sectRight'
      # oꗗo
      @f.print "\n<blockquote>"
      s = ''
      @headwords[@ids.last].each do |x|
        s += '<b>' + gaizi(x) + '</b>, '
      end
      @f.print s.sub(/, $/, '')
      @f.print "</blockquote>\n"
    when 'subconcept'
      stag = '<p>'; etag = "</p>\n"
#      stag = '<blockquote>'; etag = "</blockquote>\n"
    when nil
      if node.has_elements?
        # Related words ̏ꍇ
        if node.children[0].attributes['class'] == 'arrow_related_consept'
          stag = '<p>'; etag = "</p>\n"
        end
      end
    else
      if node.name != 'td'
        STDERR.print node.name, ':', cl, "\n"
        stag = '<p>'; etag = "</p>\n"
      end
    end

    @f.print stag
    node.each do |n|
      case n.node_type
      when :text
        @f.print gaizi(n.value) if n.value != SEP_GAIZI
      when :element
        case n.name
        when 'div', 'table', 'tr', 'td', 'p'
          block(n)
        else
          inline(n)
        end
      else
        STDERR.print n.node_type, "\n"
      end
    end
    @f.print etag

  end

  Ctags = {
    'headword_bleu_fce_b' => ['<b>', '</b>'], # ^Cgԍ
#    'headword_bleu_fce'   => ['', ''],        # ^Cg
    'textbox_nm'          => ['', ''],        # ֘ARZvgo
    'textbox_nm_i'        => ['<i>', '</i>'], #   (see)
#    'textbox_bd'          => ['<b>', '</b>'], # ֘ARZvg
    'reltitle'            => ['<p><b>', "</b></p>\n"], # ֘Aꃉx
    'reftyp'              => ['&nbsp;&nbsp;<i>', '</i>'], # ֘A (see also, opposite, etc)
#    'xblrefhwd'           => ['<b>', '</b>'], # Qƌ
  }

  def inline(node)

    case node.name
    when 'img' then return
    when 'br'  then return
    end

    cl = node.attributes['class']

    stag = ''; etag = ''
    case cl
    when 'headword_bleu_fce'     # ^Cg ({ɔ΂)
      id = @ids.last
      stag = '<b><a href="', ID_CHAR, id, '">'; etag = '</a></b>'
    when 'textbox_bd'            # ֘ARZvg
      rec = @relconcept.getrec(@relconceptid)
#      id = if rec['section'] == 0 then rec['concept'] else rec['section'] end
      id = rec['concept']
      stag = '<b><a href="', ID_CHAR, id, '">'; etag = '</a></b>'
    when 'xblrefhwd'             # Qƌ
      id = node.attributes['id'].to_i
      rec = @relword.getrec(id)
      dat = @relword.getdata(rec)
      stag = '<b><a href="', ID_CHAR, dat['targetid'], '">'; etag = '</a></b>'

      s = node.text
      if s =~ /, $/  # ؂AJ[Ɋ܂߂Ȃ
        s = $`; etag += $&
      end
      @f.print stag, s, etag
      return
    when nil
      ;
    else
      if Ctags.key?(cl)
        stag = Ctags[cl][0]; etag = Ctags[cl][1]
      else
        if node.has_text?
          STDERR.print node.name, ':', cl, "\n"
        end
      end
    end

    @f.print stag
    node.each do |n|
      case n.node_type
      when :text
        @f.print gaizi(n.value) if n.value != SEP_GAIZI
      when :element
        inline(n)
      else
        STDERR.puts n.node_type
      end
    end
    @f.print etag

  end

end

### Activator {̃f[^
class ActBody

  BULLET = '&nbsp;&nbsp;&middot;'   # ᕶ擪
#  BULLET = '@E'

  def initialize(outf)
    @f = outf
  end

  def close()
  end

  def do(source)
    doc = Document.new(source, { :ignore_whitespace_nodes => :all })
    root = doc.root

    root.elements.each do |e|
      case e.attributes['class']
      when 'titresection'
        @id = e.attributes['id']
        @f.print '<p id="', ID_CHAR, @id, '">'
        titleblock(e)
        @f.print "</p>\n"
#        @f.print "<dl>\n"
      else
        if e.name == 'span'
          inline(e)
        else
          block(e)
        end
      end
    end

#    @f.print "</dl>\n"

  end

  def titleblock(elem)

    elem.elements.each('tr/td/span') do |e|
      inline(e)
    end

  end

  def block(node)

    return if node.attributes['style'] == 'display:none;'

    cl = node.attributes['class']

    stag = etag = ''
    case cl
#    when 'titresectionM',    # ^Cg
    when 'st_m'              # o
      if node.attributes['id'] =~ /^EX\.(\d+)$/
        id = ID_CHAR + @id + '-' + $1
      else
        id = ID_CHAR + @id + '-0'
      end
#      stag = '<dt id="' + id + '">'; etag = "</dt>\n"
      stag = '<h2 id="' + id + '">&nbsp;&nbsp;'; etag = "</h2>\n"
    when 'exampleact'        # ᕶ
      stag = '<p>'; etag = "</p>\n"
    when 'hide'              # ᕶubN
      stag = '<blockquote>'; etag = "</blockquote>\n"
#      stag = '<dd>'; etag = "</dd>\n"
    when nil
      ;
    else
      case node.name
      when 'p'
        stag = '<p>'; etag = "</p>\n"
      else
        STDERR.print node.name, ':', cl, "\n"
        stag = '<p>'; etag = "</p>\n"
      end
    end

    @f.print stag
    node.each do |n|
      case n.node_type
      when :text
        @f.print gaizi(n.value)  # if n.value !~ /^\n+\z/
      when :element
        case n.name
        when 'div', 'table', 'tr', 'td', 'p'
          block(n)
        else
          inline(n)
        end
      else
        STDERR.print n.node_type, "\n"
      end
    end
    @f.print etag

  end

  Ctags = {
    "activ_bas_droite_titre_texte_b" => ['<b>', '</b>'], # ^Cgԍ
#    "activ_bas_droite_titre_texte"   => ['', ''],        # ^Cg
    "texte1"       => ['', ''],             # o
    "propformact"  => ['<p><b>', "</b></p>\n"],  # 
    "PRON"         => ['', ''],             # 
    "gramact"      => ['<i>', '</i>'],      # @ ([preposition], etc)
    "geoexpo"      => ['<i>', '</i>'],      # x (formal, etc)
    "GEO"          => ['<i>', '</i>'],      # n
    "definition"   => [' ', ''],            # `
#    "GLOSS"        => [' ', ''],            #  (=...)
    "deriv"        => ['<br><dfn>', '</dfn> '], # h
    "RELATEDWD"    => ['<i>', '</i>'],      # ֘A (also)
    "varitype"     => ['<i>', '</i> '],     # ?? (plural, also)
    "lexvar"       => ['<dfn>', '</dfn> '], # ʌ`?
    "actUSEBOLD"   => ['<b>', '</b>'],      # SVbN
    "actUSEITALIC" => ['<i>', '</i>'],      # C^bN
    "actUSEROMAN"  => ['', ''],             # [}
  }

  def inline(node)

    if node.name == 'br'
      @f.print "<br>\n"
      return
    end
#    if node.attributes['style'] == 'display:none'
#      @f.print "<br>\n"; return
#    end

    cl = node.attributes['class']

    stag = ''; etag = ''
    case cl
    when 'puce'                  # ᕶ bullet 摜
      @f.print BULLET; return
    when 'activ_bas_droite_titre_texte'   # ^Cg
      stag = '<b><a href="' + ID_CHAR + @id + ID_SUFFIX + '">' ;etag = '</a></b>'
    when 'GLOSS'                 #  (=...)
      if node.parent.attributes['class'] == 'hide'
        stag = '<p>'; etag = "</p>\n"
      end
    when nil
      case node.name
      when 'b'
        stag = '<b>'; etag = '</b>'
      end
    else
      if Ctags.key?(cl)
        stag = Ctags[cl][0]; etag = Ctags[cl][1]
      else
        if node.has_text?
          STDERR.puts cl
        end
      end
    end

    @f.print stag
    node.each do |n|
      case n.node_type
      when :text
        @f.print gaizi(n.value)   # if n.value !~ /^\n+\z/
      when :element
        inline(n)
      else
        STDERR.puts n.node_type
      end
    end
    @f.print etag

  end

end

###

if __FILE__ == $0

infname = ARGV.shift.gsub(/\\/, '/')
rs = "\x01"
data = ''
n = 0
open(infname) do |f|

  STDERR.print "Jn: ", Time::now.strftime('%Y-%m-%d %X'), "\n"

  puts '<html>'
  puts '<head>'
  puts '<title>Longman Activator</title>'
  puts '</head>'
  puts '<body>'
#  puts '<dl>'

#  while rec = DATA.gets(rs)
  while rec = f.gets(rs)
    data = rec.chop
    body = ActBody::new(data)
    body.do

    STDERR.print n, "\r" if n % 10 == 0
    n += 1
#break
    break if n >= 10
  end

  STDERR.print n, "\n"

#  puts '</dl>'
  puts '</body>'
  puts '</html>'

  STDERR.print "I: ", Time::now.strftime('%Y-%m-%d %X'), "\n"

end

end

#__END__
