if __FILE__ == $0
  scrPath = File::dirname($0.gsub(/\\/, '/')).sub(/\/ldoce4$/, '')
  $LOAD_PATH.unshift(scrPath)     # XNvgpX[hpXɒǉ
end

require 'ldoce4/package'

### 萔

# `t@C
CFG_MAIN         = 'doc.cfd'     # `t@C
CFG_ACT_CONTENTS = 'actctx.cfd'  # Activator o
CFG_EXP_LIST     = 'explist.cfi' # Activator ֘A

# doc.cat  $KEY
KEY_DIC          = 0x00  # 
KEY_ACT_CONCEPT  = 0x01  # Activator o
KEY_EXAMPLE      = 0x08  # ᕶ (Examples Bank & Pharse Bank)
KEY_ACT_BODY     = 0x09  # Activator {
KEY_IMAGE        = 0x10  # 摜
KEY_SOUND        = 0x11  # 
KEY_EXERCISE     = 0x20  # K

# avartar.cat  $PACKID (package id)
PID_ENTRY        = 0x00  # {
PID_ENTRY_FOLDED = 0x01  # o(1s)
PID_MENU         = 0x02  #  Menu
PID_USAGE_NOTE   = 0x03  #  Usage note
PID_VERB_FORM    = 0x04  #  Verb form
PID_PHRASE       = 0x05  # Phrase Bank ڎ
PID_DIC_EXAMPLE  = 0x06  # (f[^Ȃ)
PID_EXAMPLE      = 0x07  # ᕶ (APhrase Bank)
PID_PRON_GB      = 0x08  # p
PID_PRON_US      = 0x09  # č
PID_PREVIEW      = 0x0A  # k摜
PID_IMAGE        = 0x0B  # ʏ摜
PID_SOUND        = 0x0C  # 
PID_VIDEO        = 0x0D  # (f[^Ȃ)
PID_HTML_MAP     = 0x0E  # C[W}bv html
PID_IMAGE_MAP    = 0x0F  # C[W}bv摜
PID_ACT_CONCEPT  = 0x10  # Activator o(ڍ)
PID_ACT_FOLDED   = 0x11  # Activator o(1s)
PID_ACT_BODY     = 0x12  # Activator {
PID_EXERCISE     = 0x13  # K

# avartar.cat  $PTYPE (package type)
PT_TEXT          = 0x00  #  (html)
PT_SOUND         = 0x01  #  (mp3)
PT_IMAGE         = 0x03  # 摜 (jpeg)

# ID ʕ
ID_CHAR = ''          # J^O (doc.cat) ID
ID_CHAR_EXA = 'e'     # ᕶ ID
ID_SUFFIX = '-m'      # ڎp id ڔ

### .ini `t@C̊ȈՓǂݍ
###     t@Cł̏oێ
class IniData
  include Enumerable

  def initialize(path, mode = 'r')
    @table = []

    @f = File::open(path, mode)
    while line = @f.gets
      line.chomp!
      if line =~ /^\s*\[(\S+)\]/
        section = $1
        @table.push( [section, []] )
      elsif line =~ /^\s*(\S+)\s*=\s*/
        key = $1
        value = $'.sub(%r<\s*//.*$>, '')   # ߂폜
        @table.last[1].push( [key, value] )
      end
    end
    @f.close
  end

  # w̃ZNVƃL[́uŏv̒lԂ
  def value(section, key)
    @table.each do |secname, keyarray|
      if secname == section
        keyarray.each do |keyname, val|
          if keyname == key
            return val
          end
        end
      end
    end
    nil
  end

  # each([section = '*' [, key = '*']]) { |section, key, value| ...}
  # w̃ZNVƃL[̒lԂ
  # '*' ŔCӂ̃ZNV܂̓L[wł
  def each(section = '*', key = '*')
    @table.each do |x|
      if section == '*' || x[0] == section
        x[1].each do |y|
          if key == '*' || y[0] == key
            yield x[0], y[0], y[1]
          end
        end
      end
    end
  end

  # w̃ZNV̔zԂ
  # z̗vf̓L[ƒl̔z
  def sections(section)
    a = []
    @table.each do |secname, keyarray|
      if secname == section
        a.push(keyarray)
      end
    end
    return a
  end

end

### 
### [DAT]
class CfgDat
  include Enumerable

  def initialize(home, cfgname)
    @home = (home + '/').sub(%r!//$!, '/')

    @cfg = IniData::new(@home + cfgname)

    @index = Hash::new
    @indexfrec = Hash::new
    readCfg
    @indexf = open(@index['name'])
    @indexf.binmode

  end

  def close
    @indexf.close
  end

  def each
    n = 0
    until @indexf.eof?
      yield getrec(n)
      n += 1
    end
=begin
    @indexf.rewind
    until @indexf.eof?
      yield get()
    end
=end
  end

  def get
    eval(@index['read'])
    return @indexfrec
  end

  def getrec(num)
    @indexf.seek(num * @index['recsize'])
    return get()
  end

  def getdata(indexfrec = @indexfrec)
  end

  def setPrintCmd
    @printdata, @printheader = getPrintCmd
  end

  def printHeader
    eval(@printheader)
  end

  def printData(num)
    eval(@printdata)
  end

  private

  def readCfg

    @index['name'], @index['read'], @index['recsize'], @index['format'], @index['vars'] = getFiledata('DAT', 'PATH', '@indexf')

  end

  def getFiledata(section, key, f)
    name = @home + @cfg.value(section, key)

    format, recsize, vars = getFormat(section)
    var = vars.collect { |x| "#{f}rec['" + x + "']" }
    var.push('') if var.size < 2
    var = var.join(',')
    cmd = "#{var} = #{f}.read(#{recsize}).unpack('#{format}')"

    return name, cmd, recsize, format, vars
  end

  def getFormat(section)
    vars = []
    formats = []
    recsize = 0

    @cfg.each(section) do |section, key, val|
      # 擪 $ Ƃ菬ɂ̂ϐƂ
      if key =~ /^\$/
        vars.push($'.downcase)
        case val
        when 'LONG'  then formats.push('V'); recsize += 4
        when 'SHORT' then formats.push('v'); recsize += 2
        when 'BYTE'  then formats.push('C'); recsize += 1
        else
          STDERR.print 'Unknown format: ', val, "\n"
        end
      end
    end

    format = formats.join('')
    if format == ''
      format = '!'     # ^Cg𒼐ڎ擾
      vars = ['Title']
    end
    return format, recsize, vars
  end

  def getPrintCmd
    fmts = []; headerfmts = []
    fmts.push('%05d:'); headerfmts.push('No.   ')
    @index['format'].each_byte do |b|
       case b
       when ?V then fmts.push('%7d'); headerfmts.push('%-7s')
       when ?v then fmts.push('%5d'); headerfmts.push('%-5s')
       when ?C then fmts.push('%3d'); headerfmts.push('%-3s')
       end
    end
    fmtstr = fmts.join(' ') + '\n'
    headerfmtstr = headerfmts.join(' ') + '\n'

    vars = []
    vars = [ 'num' ] + @index['vars'].collect { |x| "@indexfrec['" + x + "']" }
    varstr = vars.join(',')

    headervars = []
    headervars = @index['vars'].collect { |x| "'" + x + "'" }
    headervarstr = headervars.join(',')

    headerfmtstr = '%s\n' + headerfmtstr
    headervarstr = '@index["name"], ' + headervarstr

    return %Q!printf("#{fmtstr}", #{varstr})!, %Q!printf("#{headerfmtstr}", #{headervarstr})!
  end

end

### [DAT] -> somefile
class CfgDatPlus < CfgDat

  def initialize(home, cfgname)
    @data = Hash::new
    @datafrec = Hash::new
    super
    @dataf = open(@data['name'])
    @dataf.binmode
  end

  def close
    super
    @dataf.close
  end

  private

  def getPrintCmd
    fmts = []; headerfmts = []
    fmts.push('%05d:'); headerfmts.push('No.   ')
    @index['format'].each_byte do |b|
       case b
       when ?V then fmts.push('%7d'); headerfmts.push('%-7s')
       when ?v then fmts.push('%5d'); headerfmts.push('%-5s')
       when ?C then fmts.push('%3d'); headerfmts.push('%-3s')
       end
    end
    fmts.push('-->'); headerfmts.push('-->')
    @data['format'].each_byte do |b|
       case b
       when ?V then fmts.push('%7d'); headerfmts.push('%-7s')
       when ?v then fmts.push('%5d'); headerfmts.push('%-5s')
       when ?C then fmts.push('%3d'); headerfmts.push('%-3s')
       when ?! then fmts.push('%s'); headerfmts.push('%s')
       end
    end
    fmtstr = fmts.join(' ') + '\n'
    headerfmtstr = headerfmts.join(' ') + '\n'

    vars = []
    vars = [ 'num' ] + @index['vars'].collect { |x| "@indexfrec['" + x + "']" } + @data['vars'].collect { |x| "@datafrec['" + x + "']" }
    varstr = vars.join(',')

    headervars = []
    headervars = @index['vars'].collect { |x| "'" + x + "'" } + @data['vars'].collect { |x| "'" + x + "'" }
    headervarstr = headervars.join(',')

    headerfmtstr = '%s --> %s\n' + headerfmtstr
    headervarstr = '@index["name"], @data["name"].sub(@home, ""),' + headervarstr

    return %Q!printf("#{fmtstr}", #{varstr})!, %Q!printf("#{headerfmtstr}", #{headervarstr})!
  end

end

### for *.cfi
### [DAT] -> [LIN]
class CfgLin < CfgDatPlus

  def getdata(indexfrec = @indexfrec)
    @dataf.seek(indexfrec['linof7'] * @data['recsize'])
    eval(@data['read'])

    return @datafrec
  end

  private

  def readCfg
    super
    @data['name'], @data['read'], @data['recsize'], @data['format'], @data['vars'] = getFiledata('LIN', 'PATH', '@dataf')
  end

end

### for *.cfd
### [DAT] -> [TDA]
class CfgTda < CfgDatPlus

  def getdata(indexfrec = @indexfrec)
    @dataf.seek(indexfrec['tdaof7'])
    @datafrec['Title'] = @dataf.gets("\x00").chomp("\x00")

    return @datafrec['Title']
  end

  def title(id)
    rec = getrec(id)
    return getdata(rec)
  end

  private

  def readCfg
    super
    @data['name'], @data['read'], @data['recsize'], @data['format'], @data['vars'] = getFiledata('TDA', 'PATH', '@dataf')
  end

end

### 
class Avatar < CfgDat

  def initialize(home, cfgname, drive = '')
    super(home, cfgname)

    @drive = drive
  end

  def package(n, drive = @drive)
    if @pkgs[n] == nil
      if @packages[n] =~ %r<^/.:>            # CD-ROM ̓ǂݍ
        drive = drive.sub(/:$/, '') + ':'
        name = @packages[n].sub(%r<^/.:>, drive) # hCu̒u
      else
        name = @home + @packages[n]
      end
      catname = File::dirname(name) + '/' + @catalogs[n]
      if @compressions[n] == 'ZIP'
        begin
          pkg = ZipPackage::new(catname, name)
        rescue
          pkg = nil     # Ƃ肠
        end
        @pkgs[n] = pkg
      else
        ; # ???? nil
      end
    end

    @pkgs[n]
  end

  def close
    super
    @pkgs.each do |pkg|
      pkg.close if pkg != nil
    end
  end

  def getrecs(num, count)
    a = []
    count.times do |n|
      rec = getrec(num + n)
      a.push(rec.dup)    # dup??
    end
    a
  end

  def getdata(indexfrec = @indexfrec)
    pkg = package(indexfrec['packid'])
    if pkg != nil
      return pkg.get(indexfrec['tdaof7'], indexfrec['tdalen'])
    else
      return nil
    end
  end

  private

  def readCfg
    super

    @packages = []
    @catalogs = []
    @compressions = []
    @pkgs = []

    @cfg.sections('TDA').each do |sec|
      sec.each do |key, val|
        case key
        when 'PATH'        then @packages.push(val)
        when 'CATALOG'     then @catalogs.push(val)
        when 'COMPRESSION' then @compressions.push(val)
        end
      end
      @pkgs.push(nil)
    end

=begin
    @cfg.each('TDA') do |section, key, val|
      case key
      when 'PATH'        then packages.push(val)
      when 'CATALOG'     then catalogs.push(val)
      when 'COMPRESSION' then compressions.push(val)
      end
    end

    packages.size.times do |n|
      if packages[n] =~ %r<^/.:/>           # CD-ROM ̓ǂݍ
        name = packages[n].sub(%r<^/>, '')  # ?? hCu̕ύXKv
      else
        name = @home + packages[n]
      end
      catname = File::dirname(name) + '/' + catalogs[n]
      if compressions[n] == 'ZIP'
        begin
          pkg = ZipPackage::new(catname, name)
        rescue
          pkg = nil     # Ƃ肠
        end
        @pkgs.push(pkg)
      else
        @pkgs.push(nil) # ????
      end
    end
=end

  end

end

### 
class MainDoc < CfgTda

  def initialize(home, drive = '')
    super(home, CFG_MAIN)

    @drive = drive
    @avatar = Avatar::new(@home, @avatarcfgname, @drive)
  end

  def close
    super
    @avatar.close
  end

  def getbodyindex(indexfrec = @indexfrec)
    return @avatar.getrecs(indexfrec['avtof7'], indexfrec['avtcnt'])
  end

  def getbody(avatindex)
    return @avatar.getdata(avatindex)
  end

=begin
  def getrec(num)
    get(num)
    return @avatar.get(@indexfrec['avtof7'], @indexfrec['avtcnt']), @datafrec['Title']
#    return @avatar.get(@indexfrec['avtof7'], @indexfrec['avtcnt'])
  end

  def each_rec
    n = 0
    until @indexf.eof?
      avatar, title = getrec(n)
      yield avatar, title
      n += 1
    end
  end
=end

  def package(id, drive = @drive)
    return @avatar.package(id, drive)
  end

  private

  def readCfg
    super
    @avatarcfgname = @cfg.value('AVATAR', 'PATH')
  end

end

###
if __FILE__ == $0

  Home = 'H:/ldoce4/ldoce-data/'

=begin
  ini = IniData::new(Home + CFG_MAIN)
  ini.each do |s, k, v|
    printf("[%s] %s = %s\n", s, k, v)
  end

  exit
=end

#  doc = DataCfg::new(Home, 'ldocectx.cfd')
#  doc = IdCfg::new(Home, 'phrlist.cfi')
#  doc = DataCfg::new(Home, 'phrlist.cfd')

  fname = 'hwd.cfi'
#  fname = 'explist.cfi'
#  fname = 'actldoce.cfi'
#  doc = CfgLin::new(Home, fname)

  fname = 'actctx.cfd'
#  fname = 'explist.cfd'
#  doc = CfgTda::new(Home, fname)
#  doc = CfgDat::new(Home, fname)

#=begin
  doc = MainDoc::new(Home)

  doc.setPrintCmd
  doc.printHeader
#  doc.each do |n, indexrec, datarec|
#  doc.each do |n, title, datarec|
  doc.each_with_index do |rec, n|
    doc.title
    doc.printData(n)
    a = doc.getbodyindex(rec)
p a
break if n >= 2
  end

  doc.close
#=end

=begin
  doc = MainDoc::new(Home)

id = ARGV.shift.to_i
  puts doc.title(id)
  title, a = doc.get(id)
  a.each do |x|
    key = x[1]; packid = x[2]; ptype = x[3]
    print '==== ', key, ' : ', packid, ' : ', ptype, "\n"
    puts x[0].chomp("\x00") if ptype == 0
  end

  doc.close
=end

end
