require 'zlib'

REC_SEP = "\x00"   # eLXgR[h؂蕶

class ZipPackage
  include Enumerable

  def initialize(indexfname, datafname)
    @index = open(indexfname)
    @index.binmode
    @data = open(datafname)
    @data.binmode

    @zs = Zlib::Inflate.new

    @buf = ''
    @bufPos = -1
  end

  def close
    @index.close
    @data.close
  end

  def get(pos, size)
    @index.rewind
    orgPos = 0; zipPos = 0

    until @index.eof?
      orgSize, zipSize = @index.read(8).unpack('VV')
      if orgPos + orgSize > pos
        break
      else
        orgPos += orgSize
        zipPos += zipSize
      end
    end

    if zipPos != @bufPos
      @data.seek(zipPos)
      @buf = @zs.inflate(@data.read(zipSize))
      @zs.reset   # K{
      @bufPos = zipPos
    end
    @buf[pos - orgPos, size]

  end

  def each_block
    @index.rewind
    @data.rewind

    until @index.eof?
      orgSize, zipSize = @index.read(8).unpack('VV')
      block = @zs.inflate(@data.read(zipSize))
      @zs.reset
      yield block
    end
  end

  # eLXĝ
  def each
    @index.rewind
    @data.rewind

    until @index.eof?
      orgSize, zipSize = @index.read(8).unpack('VV')
      block = @zs.inflate(@data.read(zipSize))
      @zs.reset

      start = 0
      until start >= block.size
        pos = block.index(REC_SEP, start)
        if pos != nil
          yield block[start..pos]
          start = pos + 1
        else
          yield block[start, block.size]
          start = block.size
        end
      end
    end
  end

end

####
if __FILE__ == $0

  Home = 'H:/ldoce4/ldoce-data/'

  f = 'package/cncptfld'
  indexfname = Home + f + '.tdz'
  datafname = Home + f + '.tda'

  z = ZipPackage::new(indexfname, datafname)

=begin
  z.each_block do |block|
    print block.gsub(REC_SEP, "\x01")
  end
=end
  z.each do |rec|
    print rec.gsub(REC_SEP, "\x01")
  end

#  puts z.get(452003,    520)

  z.close

end

#__END__
